/***************************************************************************
 *                          Zanoza Modeler v2.x                            *
 *      This is unpublished propietary source code of Zanoza Software.     *
 *      The copyright notice does not evidence any actual or intended      *
 *                    publication of such source code.                     *
 *                                                                         *
 *                Copyright (c) 2002-2008 Zanoza Software.                 *
 *                                                                         *
 *                        All rights reserved.                             *
 ***************************************************************************
 *--------------------------------------------------------------------------
 * @author:   Oleg Melashenko
 *--------------------------------------------------------------------------
 * @purpose:  Declaration of the class ILight
 *--------------------------------------------------------------------------
 * @created: Saturday, March 08, 2003 16:47:12
 */

#if !defined(ILight_h_included)
#define ILight_h_included
//forward declaration of this class might require
namespace scene
{ class ILight; };
#include <zmodeler.h>
#include <scene/zmSceneTypes.h>

namespace scene
{
  
  class ILight : public ZUnknown
  {
  public:
    virtual ZRESULT setType(eLightType type)=0;
    virtual ZRESULT getType(eLightType& type)=0;
    virtual ZRESULT getColor(ZColor& col)=0;
    virtual ZRESULT setColor(ZColor col)=0;
    virtual ZRESULT setDirection(ZVector& dir)=0;
    virtual ZRESULT getDirection(ZVector& dir)=0;
    virtual ZRESULT setPosition(ZPoint3D& pos)=0;
    virtual ZRESULT getPosition(ZPoint3D& pos)=0;
    virtual ZRESULT getRange(float& fRange)=0;
    virtual ZRESULT setRange(float fRange)=0;
    virtual ZRESULT setFallOff(float fValue)=0;
    virtual ZRESULT getFallOff(float& fValue)=0;
    /* Sets (depending on nIndex) attenutation 0, 1 or 2 value. */
    virtual ZRESULT setAttenuation(long nIndex, float fValue)=0;
    /* Provides (depending on nIndex) attenutation 0, 1 or 2 value. */
    virtual ZRESULT getAttenuation(long nIndex, float& fValue)=0;
    virtual ZRESULT getOuterCone(ZAngle& nAngle)=0;
    virtual ZRESULT setOuterCone(ZAngle nAngle)=0;
    virtual ZRESULT getInnerCone(ZAngle& nAngle)=0;
    virtual ZRESULT setInnerCone(ZAngle nAngle)=0;
  
  };//class ILight
};//scene

#endif
